---
title: Content-Location
slug: Web/HTTP/Headers/Content-Location
tags:
  - HTTP
  - Reference
  - header
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>Content-Location</code></strong> header indicates an alternate location for the returned data. The principal use is to indicate the URL of a resource transmitted as the result of <a href="/en-US/docs/Web/HTTP/Content_negotiation">content negotiation</a>.</p>

<p>{{HTTPHeader("Location")}} and <code>Content-Location</code> are different. <code>Location</code> indicates the URL of a redirect, while <code>Content-Location</code> indicates the direct URL to use to access the resource, without further content negotiation in the future. <code>Location</code> is a header associated with the response, while <code>Content-Location</code> is associated with the data returned. This distinction may seem abstract without <a href="#Examples">examples</a>.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Entity header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Content-Location: &lt;url&gt;
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>&lt;url&gt;</dt>
 <dd>A <a href="/en-US/docs/Learn/Common_questions/What_is_a_URL#Examples_of_relative_URLs">relative</a> (to the request URL) or <a href="/en-US/docs/Learn/Common_questions/What_is_a_URL#Examples_of_absolute_URLs">absolute</a> URL.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Requesting_data_from_a_server_in_different_formats">Requesting data from a server in different formats</h3>

<p>Let's say a site's API can return data in {{glossary("JSON")}}, {{glossary("XML")}}, or <a href="https://en.wikipedia.org/wiki/Comma-separated_values" rel="external" title="Comma-separated values">CSV</a> formats. If the URL for a particular document is at <code>https://example.com/documents/foo</code>, the site could return different URLs for <code>Content-Location</code> depending on the request's {{HTTPHeader("Accept")}} header:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Request header</th>
   <th scope="col">Response header</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>Accept: application/json, text/json</code></td>
   <td><code>Content-Location: /documents/foo.json</code></td>
  </tr>
  <tr>
   <td><code>Accept: application/xml, text/xml</code></td>
   <td><code>Content-Location: /documents/foo.xml</code></td>
  </tr>
  <tr>
   <td><code>Accept: text/plain, text/*</code></td>
   <td><code>Content-Location: /documents/foo.txt</code></td>
  </tr>
 </tbody>
</table>

<p>These URLs are examples — the site could serve the different filetypes with any URL patterns it wishes, such as a <a href="/en-US/docs/Web/API/HTMLHyperlinkElementUtils/search">query string parameter</a>: <code>/documents/foo?format=json</code>, <code>/documents/foo?format=xml</code>, and so on.</p>

<p>Then the client could remember that the JSON version is available at that particular URL, skipping content negotation the next time it requests that document.</p>

<p>The server could also consider other <a href="/en-US/docs/Web/HTTP/Content_negotiation">content negotiation</a> headers, such as {{HTTPHeader("Accept-Language")}}.</p>

<h3 id="Pointing_to_a_new_document_HTTP_201_Created">Pointing to a new document (HTTP 201 Created)</h3>

<p>Say you're creating a new blog post through a site's API:</p>

<pre>PUT /new/post
Host: example.com
Content-Type: text/markdown

# My first blog post!

I made this through `example.com`'s API. I hope it worked.
</pre>

<p>The site returns a generic success message confirming the post was published. The server specifies <em>where</em> the new post is with <code>Content-Location</code>:</p>

<pre>HTTP/1.1 201 Created
Content-Type: text/plain; charset=utf-8
Content-Location: /my-first-blog-post

✅ Success!
</pre>

<h3 id="Indicating_the_URL_of_a_transactions_result">Indicating the URL of a transaction's result</h3>

<p>Say you have a <code><a href="/en-US/docs/Web/HTML/Element/form">&lt;form&gt;</a></code> for sending money to another user of a site.</p>

<pre class="brush: html">&lt;form action="/send-payment" method="post"&gt;
  &lt;p&gt;
    &lt;label&gt;Who do you want to send the money to?
      &lt;input type="text" name="recipient"&gt;
    &lt;/label&gt;
  &lt;/p&gt;

  &lt;p&gt;
    &lt;label&gt;How much?
      &lt;input type="number" name="amount"&gt;
    &lt;/label&gt;
  &lt;/p&gt;

  &lt;button type="submit"&gt;Send Money&lt;/button&gt;
&lt;/form&gt;
</pre>

<p>When the form is submitted, the site generates a receipt for the transaction. The server could use <code>Content-Location</code> to indicate that receipt's URL for future access.</p>

<pre>HTTP/1.1 200 OK
Content-Type: text/html; charset=utf-8
Content-Location: /my-receipts/38

&lt;!doctype html&gt;
<em>(Lots of HTML…)</em>

&lt;p&gt;You sent $38.00 to ExampleUser.&lt;/p&gt;

<em>(Lots more HTML…)</em>
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7231", "Content-Location", "3.1.4.2")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Content-Location")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Location")}}</li>
</ul>
